;; My Galaxy spaceship game
;; Copyright (C) 2017 AyMy Studios
;;
;; This program is free software: you can redistribute it and/or modify
;; it under the terms of the GNU General Public License as published by
;; the Free Software Foundation, either version 3 of the License, or
;; (at your option) any later version.
;;
;; This program is distributed in the hope that it will be useful,
;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see <http://www.gnu.org/licenses/>.

.area _DATA

;;Necesitamos los datos de entidad y sus indices
.include "headers/entity.h.s"

.area _CODE

;;===================================================
;;Se encarga de colisiones enemy-bullet
;:DESTROYS: AF, BC, IX, IY
;;===================================================
collision_bullet::
   ld    a, (disparando)
   cp    #0
   ret   z

   call  bullet_getPointerIY
   call  check
   cp    #1
   ret   nz
   call  enemy_reset
   call  player_kill
   call  bullet_delete
   ret


;;===================================================
;;Se encarga de colisiones enemy-player
;:DESTROYS: AF, BC, IX, IY
;;===================================================
collision_player::
   call  player_getPointerIY
   call  check
   cp    #1
   ret   nz
   call  player_hit
   call  enemy_reset
   ret

;;===================================================
;;Comprueba colisiones entre objetos
;;INPUTS:
;;    IX => Puntero a objeto "on board"
;;    IY => Puntero a objeto obstaculo
;;DESTROYS: AF, BC
;;RETURNS:
;;    C => 0 (no hay colision) o 1 (colision)
;;===================================================
check::
   ;;A la izquierda (object_x + object_w - obstacle_x <= 0)
   ld    a, ent_x(ix)
   ld    b, ent_w(ix)
   ld    c, ent_x(iy)
   add   b
   sub   c
   jr    z, no_collision
   jp    m, no_collision

   ;;A la derecha (obstacle_x + obstacle_w - object_x <= 0)
   ld    a, ent_x(iy)
   ld    b, ent_w(iy)
   ld    c, ent_x(ix)
   add   b
   sub   c
   jr    z, no_collision
   jp    m, no_collision

   ;;Arriba (object_y + object_h - obstacle_y <= 0)
   ld    a, ent_y(ix)
   ld    b, ent_h(ix)
   ld    c, ent_y(iy)
   add   b
   sub   c
   jr    z, no_collision
   jp    m, no_collision

   ;;Abajo (obstacle_y + obstacle_h - object_y <= 0)
   ld    a, ent_y(iy)
   ld    b, ent_h(iy)
   ld    c, ent_y(ix)
   add   b
   sub   c
   jr    z, no_collision
   jp    m, no_collision

   ;;Colision
   ld    a, #1
   ret

   ;;No hay colision
   no_collision:
   ld    a, #0
   ret