;; My Galaxy spaceship game
;; Copyright (C) 2017 AyMy Studios
;;
;; This program is free software: you can redistribute it and/or modify
;; it under the terms of the GNU General Public License as published by
;; the Free Software Foundation, either version 3 of the License, or
;; (at your option) any later version.
;;
;; This program is distributed in the hope that it will be useful,
;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see <http://www.gnu.org/licenses/>.


.area _DATA

.include "headers/entity.h.s"
.include "headers/enemy.h.s"

;;CPCtelera symbols
.globl cpct_getRandom_glfsr16_u8_asm

.area _CODE

;;===================================================
;;Llama al update de todos los enemigos
;;DESTROYS: AF, BC, DE, HL, IX
;;===================================================
enemy_update::
   call enemy_M_update
   call enemy_H_update
   call enemy_V_update
   ret

;;===================================================
;;Llama al erase, draw y drawUpdate de todos los enemigos
;;DESTROYS: AF, BC, DE, HL, IX
;;===================================================
enemy_render::
   call enemy_M_render
   call enemy_H_render
   call enemy_V_render
   ret

;;===================================================
;;Crea un numero aleatorio entre 10 y 70
;;DESTROYS: AF, HL, BC
;;===================================================
calcula_random_x:
   call cpct_getRandom_glfsr16_u8_asm
   ld   l,a
   ld   h, #4
   ld   bc, #45
   mod_loop_x:
      or   a
      sbc  hl, bc
      jp   p, mod_loop_x
   add  hl, bc
   ld   bc, #4
   add  hl, bc
   ld   a, l
   ret

;;===================================================
;;Crea un numero aleatorio entre 10 y 170
;;INPUTS: IX => Puntero al enemigo
;;DESTROYS: AF, HL, BC
;;===================================================
calcula_random_y:
   call cpct_getRandom_glfsr16_u8_asm
   ld   l,a
   ld   h, #30
   ld   bc, #170
   mod_loop_y:
      or   a
      sbc  hl, bc
      jp   p, mod_loop_y
   add  hl, bc
   ld   bc, #4
   add  hl, bc
   ld   a, l
   ret


;;===================================================
;;LLama al reset adecuado
;;INPUTS: IX => Puntero al enemigo a mover
;;DESTROYS: AF
;;===================================================
enemy_reset::
   ld    a, ent_move(ix)
   cp    #0
   jr    nz, no_up
      call  enemy_resetUp
      ret
   no_up:

   ld    a, ent_move(ix)
   cp    #1
   jr    nz, no_down
      call  enemy_resetDown
      ret
   no_down:

   ld    a, ent_move(ix)
   cp    #2
   jr    nz, no_left
      call  enemy_resetLeft
      ret
   no_left:

   call  enemy_resetRight

   ret


;;===================================================
;;Devuelve a un enemigo a otra posicion aleatoria
;;INPUTS: IX => Puntero al enemigo a mover
;;DESTROYS: AF
;;===================================================
enemy_resetUp:
   call calcula_random_x     
   ld    ent_x(ix), a    
   ld    a, ent_max_y(ix) 
   ld    ent_y(ix), a
   ret

;;===================================================
;;Devuelve a un enemigo a otra posicion aleatoria
;;INPUTS: IX => Puntero al enemigo a mover
;;DESTROYS: AF
;;===================================================
enemy_resetDown:
   call calcula_random_x     
   ld    ent_x(ix), a     
   ld    ent_y(ix), #4
   ret

;;===================================================
;;Devuelve a un enemigo a otra posicion aleatoria
;;INPUTS: IX => Puntero al enemigo a mover
;;DESTROYS: AF
;;===================================================
enemy_resetLeft:
   ld    a, ent_max_x(ix)
   ld    ent_x(ix), a     
   call calcula_random_y    
   ld    ent_y(ix), a
   ret

;;===================================================
;;Devuelve a un enemigo a otra posicion aleatoria
;;INPUTS: IX => Puntero al enemigo a mover
;;DESTROYS: AF
;;===================================================
enemy_resetRight:
   ld    ent_x(ix), #4     
   call calcula_random_y   
   ld    ent_y(ix), a
   ret
