;; My Galaxy spaceship game
;; Copyright (C) 2017 AyMy Studios
;;
;; This program is free software: you can redistribute it and/or modify
;; it under the terms of the GNU General Public License as published by
;; the Free Software Foundation, either version 3 of the License, or
;; (at your option) any later version.
;;
;; This program is distributed in the hope that it will be useful,
;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see <http://www.gnu.org/licenses/>.


.area _DATA

.include "headers/entity.h.s"
.include "headers/entity_inherited.h.s"

.globl _sprite_misil_Iz
.globl _sprite_misil_De

new enemy_0 50, 30, 8, 7, _sprite_misil_Iz, 1, 2
new enemy_1  4, 20, 8, 7, _sprite_misil_De, 1, 3 

.area _CODE

;;===================================================
;;Llama a los updates de los enemy_H creados
;;DESTROYS: AF, IX
;;===================================================
enemy_H_update::
   ld    a, (player_nivel)
   cp    #3
   jr    z, enemy0_u
   cp    #4
   jr    z, enemy1_u
   cp    #6
   jr    z, enemy0_u

   ret

   enemy0_u:

   ld    ix, #enemy_0_data
   call  update_left
   call  collision_bullet
   call  collision_player

   ld    a, (player_nivel)
   cp    #6
   ret   nz

   enemy1_u:

   ld    ix, #enemy_1_data
   call  update_right
   call  collision_bullet
   call  collision_player

   ret

enemy_H_render::
   ld    a, (player_nivel)
   cp    #3
   jr    z, enemy0_r
   cp    #4
   jr    z, enemy1_r
   cp    #6
   jr    z, enemy0_r

   ret

   enemy0_r:

   ld    ix, #enemy_0_data
   call entity_erase
   call entity_draw
   call entity_drawUpdate

   ld    a, (player_nivel)
   cp    #6
   ret   nz

   enemy1_r:

   ld    ix, #enemy_1_data
   call entity_erase
   call entity_draw
   call entity_drawUpdate

   ret


;;===================================================
;;Mueve el enemigo por pantalla hacia la derecha
;;INPUTS: IX => Puntero al enemigo
;;DESTROYS: AF
;;===================================================
update_left:
   ld    a, ent_x(ix) 
   ld    b, ent_speed(ix)
   sub   b
   ld    ent_x(ix), a
   cp    #4
   ret   nc
   call  enemy_resetLeft 
   ret

;;===================================================
;;Mueve el enemigo por pantalla hacia la derecha
;;INPUTS: IX => Puntero al enemigo
;;DESTROYS: AF
;;===================================================
update_right:
   ld    a, ent_x(ix) 
   ld    b, ent_speed(ix)
   add   b
   ld    ent_x(ix), a
   cp    ent_max_x(ix)
   ret   c
   call  enemy_resetRight
   ret