;; My Galaxy spaceship game
;; Copyright (C) 2017 AyMy Studios
;;
;; This program is free software: you can redistribute it and/or modify
;; it under the terms of the GNU General Public License as published by
;; the Free Software Foundation, either version 3 of the License, or
;; (at your option) any later version.
;;
;; This program is distributed in the hope that it will be useful,
;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see <http://www.gnu.org/licenses/>.


.area _DATA

.include "headers/entity.h.s"
.include "headers/entity_inherited.h.s"

.globl _sprite_Huevo

new enemy_0 50, 5, 8, 20, _sprite_Huevo, 1, 1
new enemy_1 10, 5, 8, 20, _sprite_Huevo, 1, 1

.area _CODE

;;===================================================
;;Llama a los updates de los enemy_M creados
;;DESTROYS: AF, IX
;;===================================================
enemy_M_update::
   ld    a, (player_nivel)
   cp    #6
   jr    c, enemy0_u

   ret

   enemy0_u:

   ld    ix, #enemy_0_data
   call  update
   call  collision_bullet
   call  collision_player

   ld    a, (player_nivel)
   cp    #1
   jr    z, enemy1_u
   cp    #4
   jr    z, enemy1_u

   ret

   enemy1_u:

   ld    ix, #enemy_1_data
   call  update
   call  collision_bullet
   call  collision_player

   ret

;;===================================================
;;Mueve el enemigo por pantalla hacia abajo
;;INPUTS: IX => Puntero al enemigo
;;DESTROYS: AF, BC
;;===================================================
update:
   ld    a, ent_y(ix) 
   ld    b, ent_speed(ix)
   add   b
   ld    ent_y(ix), a
   cp    ent_max_y(ix)
   ret   c
   call  enemy_resetDown 
   ret

enemy_M_render::
   ld    a, (player_nivel)
   cp    #6
   jr    c, enemy0_r

   ret

   enemy0_r:

   ld    ix, #enemy_0_data
   call entity_erase
   call entity_draw
   call entity_drawUpdate

   ld    a, (player_nivel)
   cp    #1
   jr    z, enemy1_r
   cp    #4
   jr    z, enemy1_r

   ret

   enemy1_r:

   ld    ix, #enemy_1_data
   call entity_erase
   call entity_draw
   call entity_drawUpdate

   ret

   
