;; My Galaxy spaceship game
;; Copyright (C) 2017 AyMy Studios
;;
;; This program is free software: you can redistribute it and/or modify
;; it under the terms of the GNU General Public License as published by
;; the Free Software Foundation, either version 3 of the License, or
;; (at your option) any later version.
;;
;; This program is distributed in the hope that it will be useful,
;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see <http://www.gnu.org/licenses/>.


.area _DATA

.include "headers/entity.h.s"
.include "headers/entity_inherited.h.s"

.globl _sprite_enemigo_Arriba
.globl _sprite_enemigo_Abajo

new enemy_0 50, 5, 8, 20, _sprite_enemigo_Abajo, 2, 1
new enemy_1 10, 175, 8, 20, _sprite_enemigo_Arriba, 1, 0

.area _CODE

;;===================================================
;;Llama a los updates de los enemy_V creados
;;DESTROYS: AF, IX
;;===================================================
enemy_V_update::
   ld    a, (player_nivel)
   cp    #2
   jr    z, enemy0_u
   cp    #3
   jr    z, enemy1_u
   cp    #5
   jr    z, enemy0_u
   cp    #6
   jr    z, enemy0_u

   ret 

   enemy0_u:

   ld    ix, #enemy_0_data
   call  update_down
   call  collision_bullet
   call  collision_player

   ld    a, (player_nivel)
   cp    #5
   ret   c

   enemy1_u:

   ld    ix, #enemy_1_data
   call  update_up
   call  collision_bullet
   call  collision_player

   ret

enemy_V_render::
   ld    a, (player_nivel)
   cp    #2
   jr    z, enemy0_r
   cp    #3
   jr    z, enemy1_r
   cp    #5
   jr    z, enemy0_r
   cp    #6
   jr    z, enemy0_r

   ret

   enemy0_r:

   ld    ix, #enemy_0_data
   call entity_erase
   call entity_draw
   call entity_drawUpdate

   ld    a, (player_nivel)
   cp    #5
   ret   c

   enemy1_r:

   ld    ix, #enemy_1_data
   call entity_erase
   call entity_draw
   call entity_drawUpdate

   ret

;;===================================================
;;Mueve el enemigo por pantalla hacia arriba
;;INPUTS: IX => Puntero al enemigo
;;DESTROYS: AF
;;===================================================
update_up:
   ld    a, ent_y(ix) 
   ld    b, ent_speed(ix)
   sub   b
   ld    ent_y(ix), a
   cp    #4
   ret   nc
   call  enemy_resetUp 
   ret

;;===================================================
;;Mueve el enemigo por pantalla hacia abajo
;;INPUTS: IX => Puntero al enemigo
;;DESTROYS: AF
;;===================================================
update_down:
   ld    a, ent_y(ix) 
   ld    b, ent_speed(ix)
   add   b
   ld    ent_y(ix), a
   cp    ent_max_y(ix)
   ret   c
   call  enemy_resetDown 
   ret