;; My Galaxy spaceship game
;; Copyright (C) 2017 AyMy Studios
;;
;; This program is free software: you can redistribute it and/or modify
;; it under the terms of the GNU General Public License as published by
;; the Free Software Foundation, either version 3 of the License, or
;; (at your option) any later version.
;;
;; This program is distributed in the hope that it will be useful,
;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see <http://www.gnu.org/licenses/>.

;;Macro para crear entidades
.macro new name, x, y, w, h, sprite, speed, move
   name'_data:
      name'_x:       .db x, x, x
      name'_y:       .db y, y, y
      name'_w:       .db w
      name'_h:       .db h
      name'_sprite:  .dw sprite 
      name'_speed:   .db speed
      name'_move:    .db move         ;;[0, 3] => {Arriba, Abajo, Izquierda, Derecha} 
      name'_max_x:   .db #58-w
      name'_max_y:   .db #195-h
      name'_drawC:   .db #2
.endm

;;Indices de los datos de entidades
.equ ent_x, 0
.equ ent_y, 3
.equ ent_w, 6
.equ ent_h, 7
.equ ent_sprite_l, 8
.equ ent_sprite_h, 9	
.equ ent_speed, 10
.equ ent_move, 11
.equ ent_max_x, 12
.equ ent_max_y, 13
.equ ent_drawC, 14

;;Collisiones
.globl collision_bullet
.globl collision_player
.globl disparando
.globl player_kill
.globl player_hit
.globl bullet_delete

.globl enemy_reset
.globl enemy_resetUp
.globl enemy_resetDown
.globl enemy_resetLeft
.globl enemy_resetRight

;;Doble buffer
.globl entity_drawUpdate

;;Getters
.globl player_getPointerIX
.globl player_getPointerIY
.globl bullet_getPointerIY

;;Info extra
.globl player_nivel