;; My Galaxy spaceship game
;; Copyright (C) 2017 AyMy Studios
;;
;; This program is free software: you can redistribute it and/or modify
;; it under the terms of the GNU General Public License as published by
;; the Free Software Foundation, either version 3 of the License, or
;; (at your option) any later version.
;;
;; This program is distributed in the hope that it will be useful,
;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see <http://www.gnu.org/licenses/>.


.area _DATA

.include "headers/hud.h.s"

main_menu_dibujado:     .db #0
controls_menu_dibujado: .db #0
marco_dibujado:         .db #0
initial_text_dibujado:  .db #0
game_over_dibujado:     .db #0

;;Estan todas a 0, pero en codigo ASCII
millares_punt: .db #48
centenas_punt: .db #48
decenas_punt:  .db #48
unidades_punt: .db #48

;;Macro para crear entidades
.macro new name, w, h, sprite
   name'_data:
      name'_w:       .db w
      name'_h:       .db h
      name'_sprite:  .dw sprite 
.endm

;;Indices de los datos de entidades
.equ car_w, 0
.equ car_h, 1
.equ car_sprite_l, 2
.equ car_sprite_h, 3

new cartel 24, 28, _sprite_Logo

.area _CODE

;;===================================================
;;Dibuja un cartel en el menu principal
;:DESTROYS: HL, DE, AF, BC
;;===================================================
hud_draw_cartel:
   ld    de, #0xC000               
   ld    c, #26            
   ld    b, #44            
   call  cpct_getScreenPtr_asm   ;;Coje el puntero a la pantalla y lo guarda en HL

   ;;Dibujamos un sprite
   ex    de, hl                  ;;Puntero a la posicion de memoria en DE
   ld    hl, (cartel_sprite)
   ld    c, #24
   ld    b, #28
   call  cpct_drawSprite_asm
   ret
;;===================================================
;;Dibuja el menu principal
;:DESTROYS: HL, DE, AF, BC
;;===================================================
hud_draw_main_menu::
   ld    a, (main_menu_dibujado)
   cp    #1
   ret   z

   ;;INPUTS de la funcion
   ;;Como tiene 6 hay que meter 2 en la pila
   ;;  Pila => Direccion del tilemap
   ;;  Pila => Direccion inicio memoria de video
   ;;    B  => Coordenada y del primer tile a dibujar
   ;;    C  => Coordenada x del primer tile a dibujar
   ;;    D  => Alto en tiles de la parte a dibujar
   ;;    E  => Ancho en tiles de la parte a dibujar
   ;;    A  => Ancho total en tiles del mapa
   ld    hl, #_menu
   push  hl
;    call  video_getVideoPointer
;    push  de
   ld    hl, #0xC000
   push  hl
   ld    bc, #0000
   ld     d, #50
   ld     e, #40
   ld     a, #40

   call cpct_etm_drawTileBox2x4_asm

   call hud_draw_cartel

   ;;Copiamos al buffer secundario
   ld    hl, #0xC000
   ld    de, #0x8000
   ld    bc, #0x4000
   ldir

   ;;Marcamos como dibujado
   ld    a, #1
   ld    (main_menu_dibujado), a

   ;;Y lo demas como no dibujado
   ld    a, #0
   ld    (controls_menu_dibujado), a
   ld    (marco_dibujado), a
   ld    (initial_text_dibujado), a
   ld    (game_over_dibujado), a

   ld    a, #4
   ld    (vel_musica), a

   ret

;;===================================================
;;Dibuja la pantalla de controles
;:DESTROYS: HL, DE, AF, BC
;;===================================================
hud_draw_controls_menu::
   ld    a, (controls_menu_dibujado)
   cp    #1
   ret   z

   ;;INPUTS de la funcion
   ;;Como tiene 6 hay que meter 2 en la pila
   ;;  Pila => Direccion del tilemap
   ;;  Pila => Direccion inicio memoria de video
   ;;    B  => Coordenada y del primer tile a dibujar
   ;;    C  => Coordenada x del primer tile a dibujar
   ;;    D  => Alto en tiles de la parte a dibujar
   ;;    E  => Ancho en tiles de la parte a dibujar
   ;;    A  => Ancho total en tiles del mapa
   ld    hl, #_controls
   push  hl
;    call  video_getVideoPointer
;    push  de
   ld    hl, #0xC000
   push  hl
   ld    bc, #0000
   ld     d, #50
   ld     e, #40
   ld     a, #40

   call cpct_etm_drawTileBox2x4_asm

   ;;Copiamos al buffer secundario
   ld    hl, #0xC000
   ld    de, #0x8000
   ld    bc, #0x4000
   ldir

   ;;Marcamos como dibujado
   ld    a, #1
   ld    (controls_menu_dibujado), a

   ;;Y lo demas como no dibujado
   ld    a, #0
   ld    (main_menu_dibujado), a
   ld    (marco_dibujado), a
   ld    (initial_text_dibujado), a
   ld    (game_over_dibujado), a

   ld    a, #6
   ld    (vel_musica), a

   ret

;;===================================================
;;Dibuja el tilemap de la partida
;:DESTROYS: HL, DE, AF, BC
;;===================================================
hud_draw_marco::
   ld    a, (marco_dibujado)
   cp    #1
   ret   z

   ;;INPUTS de la funcion
   ;;Como tiene 6 hay que meter 2 en la pila
   ;;  Pila => Direccion del tilemap
   ;;  Pila => Direccion inicio memoria de video
   ;;    B  => Coordenada y del primer tile a dibujar
   ;;    C  => Coordenada x del primer tile a dibujar
   ;;    D  => Alto en tiles de la parte a dibujar
   ;;    E  => Ancho en tiles de la parte a dibujar
   ;;    A  => Ancho total en tiles del mapa
   ld    hl, #_marco
   push  hl
;    call  video_getVideoPointer
;    push  de
   ld    hl, #0xC000
   push  hl
   ld    bc, #0000
   ld     d, #50
   ld     e, #40
   ld     a, #40

   call cpct_etm_drawTileBox2x4_asm

   ;;Marcamos como dibujado
   ld    a, #1
   ld    (marco_dibujado), a

   ;;Y lo demas como no dibujado
   ld    a, #0
   ld    (main_menu_dibujado), a
   ld    (controls_menu_dibujado), a
   ld    (initial_text_dibujado), a
   ld    (game_over_dibujado), a

   ld    a, #6
   ld    (vel_musica), a

   ret

;;===================================================
;;Dibuja la pantalla de Game Over
;:DESTROYS: HL, DE, AF, BC
;;===================================================
hud_draw_initial_text::
   ld    a, (initial_text_dibujado)
   cp    #1
   ret   z

   ;;Unidades puntuacion
   ld    a, (unidades_punt)
   ld    b, #48
   ld    c, #74
   call  hud_draw_char

   ;;Decenas puntuacion
   ld    a, (decenas_punt)
   ld    b, #48
   ld    c, #70
   call  hud_draw_char

   ;;Centenas puntuacion
   ld    a, (centenas_punt)
   ld    b, #48
   ld    c, #66
   call  hud_draw_char

   ;;Millares puntuacion
   ld    a, (millares_punt)
   ld    b, #48
   ld    c, #62
   call  hud_draw_char

   ;;Nivel
   ld    a, #49
   ld    b, #84
   ld    c, #68
   call  hud_draw_char

   ;;X en vidas
   ld    a, #88
   ld    b, #112
   ld    c, #69
   call  hud_draw_char

   ;;Numero de vidas
   ld    a, #51
   ld    b, #112
   ld    c, #74
   call  hud_draw_char

   ;;Copiamos al buffer secundario
   ld    hl, #0xC000
   ld    de, #0x8000
   ld    bc, #0x4000
   ldir

   ;;Marcamos como dibujado
   ld    a, #1
   ld    (initial_text_dibujado), a

   ;;Y lo demas como no dibujado
   ld    a, #0
   ld    (main_menu_dibujado), a
   ld    (controls_menu_dibujado), a
   ld    (game_over_dibujado), a
   ret

;;===================================================
;;Dibuja la pantalla de Game Over
;:DESTROYS: HL, DE, AF, BC
;;===================================================
hud_draw_game_over::
   ld    a, (game_over_dibujado)
   cp    #1
   ret   z

   ;;INPUTS de la funcion
   ;;Como tiene 6 hay que meter 2 en la pila
   ;;  Pila => Direccion del tilemap
   ;;  Pila => Direccion inicio memoria de video
   ;;    B  => Coordenada y del primer tile a dibujar
   ;;    C  => Coordenada x del primer tile a dibujar
   ;;    D  => Alto en tiles de la parte a dibujar
   ;;    E  => Ancho en tiles de la parte a dibujar
   ;;    A  => Ancho total en tiles del mapa
   ld    hl, #_gameOver
   push  hl
;    call  video_getVideoPointer
;    push  de
   ld    hl, #0xC000
   push  hl
   ld    bc, #0000
   ld     d, #50
   ld     e, #40
   ld     a, #40

   call cpct_etm_drawTileBox2x4_asm

   ;;Copiamos al buffer secundario
   ld    hl, #0xC000
   ld    de, #0x8000
   ld    bc, #0x4000
   ldir

   ;;Marcamos como dibujado
   ld    a, #1
   ld    (game_over_dibujado), a

   ;;Y lo demas como no dibujado
   ld    a, #0
   ld    (main_menu_dibujado), a
   ld    (controls_menu_dibujado), a
   ld    (initial_text_dibujado), a
   ld    (marco_dibujado), a

   ld    a, #6
   ld    (vel_musica), a

   ret


;;===================================================
;;Dibuja un caracter
;;INPUTS:
;;    A => ASCII del caracter a imprimir
;;    B => Coordenada y (bytes)
;;    C => Coordenada x (bytes)
;;DESTROYS: AF, BC, DE, HL
;;===================================================
hud_draw_char::
   push  bc
   push  af
   ;;Calcula la posicion en pantalla
;    call  video_getVideoPointer   ;;Cargamos la posicion inicial de video en DE
   ld    de, #0xC000
   call  cpct_getScreenPtr_asm   ;;Obtenemos el puntero a la posicion deseada en HL
   ex    de, hl                  ;;Como necesitamos el puntero en DE, intercambiamos con HL

   ;;Dibujamos el caracter
   pop   af
   push  af
   ld    b, #1                   ;;Cargamos en B el indice en la paleta del color azul marino
   ld    c, #15                  ;;Cargamos en C el indice en la paleta del color blanco
   call cpct_drawCharM0_asm      ;;Dibujamos el caracter
   
   pop  af
   pop  bc
   push af
   ld   de, #0x8000
   call cpct_getScreenPtr_asm
   ex   de, hl

   pop af
   ld    b, #1                   ;;Cargamos en B el indice en la paleta del color azul marino
   ld    c, #15                  ;;Cargamos en C el indice en la paleta del color blanco
   call cpct_drawCharM0_asm      ;;Dibujamos el caracter   

   ret

;;===================================================
;;Cambia el numero de vidas
;;INPUTS:
;;    A => Vidas restantes
;;DESTROYS: AF, BC, DE, HL
;;===================================================
hud_update_lives::
   add   #48         ;;48 es el ASCII del 0
   ld    b, #112
   ld    c, #74
   call  hud_draw_char   
   ret

;;===================================================
;;Cambia el numero de vidas
;;DESTROYS: AF, BC, DE, HL
;;===================================================
hud_update_score::
   ;;Unidades
   ld    a, (unidades_punt)
   inc   a
   push  af
   ld    (unidades_punt), a
   pop   af
   cp    #58
   jr    nz, no_subir_decenas
      ld    a, #48
      ld    (unidades_punt), a
      push  af
      ld    a, (decenas_punt)
      inc   a
      ld    (decenas_punt), a
      pop   af
   no_subir_decenas:
   ld    b, #48
   ld    c, #74
   call  hud_draw_char

   ;;Decenas
   ld    a, (decenas_punt)
   cp    #58
   jr    nz, no_subir_centenas
      ld    a, #48
      ld    (decenas_punt), a
      push  af
      ld    a, (centenas_punt)
      inc   a
      ld    (centenas_punt), a
      pop   af
   no_subir_centenas:
   ld    b, #48
   ld    c, #70
   call  hud_draw_char

   ;;Centenas
   ld    a, (centenas_punt)
   cp    #58
   jr    nz, no_subir_millares
      ld    a, #48
      ld    (centenas_punt), a
      push  af
      ld    a, (millares_punt)
      inc   a
      ld    (millares_punt), a
      pop   af
   no_subir_millares:
   ld    b, #48
   ld    c, #66
   call  hud_draw_char

   ;;Millares
   ld    a, (millares_punt)
   ld    b, #48
   ld    c, #62
   call  hud_draw_char

   ret

;;===================================================
;;Resetea la puntuacion
;;DESTROYS: AF, BC, DE, HL
;;===================================================
hud_reset_score::
   ld    a, #48
   ld    (unidades_punt), a
   ld    (decenas_punt), a
   ld    (centenas_punt), a
   ld    (millares_punt), a
   
   ;;Unidades
   ld    b, #48
   ld    c, #74
   call  hud_draw_char

   ;;Decenas
   ld    a, #48
   ld    b, #48
   ld    c, #70
   call  hud_draw_char

   ;;Centenas
   ld    a, #48
   ld    b, #48
   ld    c, #66
   call  hud_draw_char

   ;;Millares
   ld    a, #48
   ld    b, #48
   ld    c, #62
   call  hud_draw_char

   ret

;;===================================================
;;Aumenta el contador de nivel
;;DESTROYS: AF, BC, DE, HL
;;===================================================
hud_update_level::
   add   #48
   ld    b, #84
   ld    c, #68
   call  hud_draw_char 
   ret


;;===================================================
;;Resetea el contador de nivel
;;DESTROYS: AF, BC, DE, HL
;;===================================================
hud_reset_level::
   ld    a, #49
   ld    b, #84
   ld    c, #68
   call  hud_draw_char 
   ret