;; My Galaxy spaceship game
;; Copyright (C) 2017 AyMy Studios
;;
;; This program is free software: you can redistribute it and/or modify
;; it under the terms of the GNU General Public License as published by
;; the Free Software Foundation, either version 3 of the License, or
;; (at your option) any later version.
;;
;; This program is distributed in the hope that it will be useful,
;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see <http://www.gnu.org/licenses/>.


.area  _DATA

.include "headers/video.h.s"

video_pointer:: .dw #0x8000

.area _CODE

video_switchBuffers::
   modifier = .+1
   ld    l, #0x20
   call  cpct_setVideoMemoryPage_asm
   ld    hl, #modifier
   ld    a, #0x10
   xor   (hl)
   ld    (modifier), a

   ld    hl, #video_pointer+1
   ld    a, #0x40
   xor   (hl)
   ld    (video_pointer+1), a

   ret

video_copyBuffer::
   ld    a, (video_pointer)
   cp    #0xC000

   jr    z, buffer_2
      ld    hl, #0x8000
      ld    de, #0xC000
      ld    bc, #0x4000
      ldir
      ret
   buffer_2:
   ld    hl, #0xC000
   ld    de, #0x8000
   ld    bc, #0x4000
   ldir

   ret

video_getVideoPointer::
   ld    hl, (video_pointer)
   ex    de, hl
   ret

video_getBackVideoPointer::
   ld    hl, #video_pointer+1
   ld    a, #0x40
   xor   (hl)
   ld    l, a
   ld    h, #0x00
   ex    de, hl
   ret

video_setBuffer_CO::
   ld    l, #0x30
   call  cpct_setVideoMemoryPage_asm
   ld    a, #0xC000
   ld    (video_pointer), a
   ret